Loading...
Searching...
No Matches
juce::Line< ValueType > Class Template Reference

## Detailed Description

template<typename ValueType>
class juce::Line< ValueType >

Represents a line.

This class contains a bunch of useful methods for various geometric tasks.

The ValueType template parameter should be a primitive type - float or double are what it's designed for. Integer types will work in a basic way, but some methods that perform mathematical operations may not compile, or they may not produce sensible results.

See also
  Point, Rectangle, Path, Graphics::drawLine

The documentation for this class was generated from the following file:

- juce_graphics/geometry/juce_Line.h

## Public Member Functions

| Line ()=default
| Creates a line, using (0, 0) as its start and end points.
| Line (const Line &)=default
| Creates a copy of another line.
| Line (ValueType startX, ValueType startY, ValueType endX, ValueType endY) noexcept
| Creates a line based on the coordinates of its start and end points.
| Line (Point< ValueType > startPoint, Point< ValueType > endPoint) noexcept
| Creates a line from its start and end points.
Line & | operator= (const Line &)=default
| Copies a line from another one.
| ~Line ()=default
| Destructor.
ValueType | getStartX () const noexcept
| Returns the x coordinate of the line's start point.
ValueType | getStartY () const noexcept
| Returns the y coordinate of the line's start point.
ValueType | getEndX () const noexcept
| Returns the x coordinate of the line's end point.
ValueType | getEndY () const noexcept
| Returns the y coordinate of the line's end point.
Point< ValueType > | getStart () const noexcept
| Returns the line's start point.
Point< ValueType > | getEnd () const noexcept
| Returns the line's end point.
void | setStart (ValueType newStartX, ValueType newStartY) noexcept
| Changes this line's start point.
void | setEnd (ValueType newEndX, ValueType newEndY) noexcept
| Changes this line's end point.
void | setStart (const Point< ValueType > newStart) noexcept
| Changes this line's start point.
void | setEnd (const Point< ValueType > newEnd) noexcept
| Changes this line's end point.
Line | reversed () const noexcept
| Returns a line that is the same as this one, but with the start and end reversed,.
void | applyTransform (const AffineTransform &transform) noexcept
| Applies an affine transform to the line's start and end points.
ValueType | getLength () const noexcept
| Returns the length of the line.
ValueType | getLengthSquared () const noexcept
| Returns the length of the line.
bool | isVertical () const noexcept
| Returns true if the line's start and end x coordinates are the same.
bool | isHorizontal () const noexcept
| Returns true if the line's start and end y coordinates are the same.
Point< ValueType >::FloatType | getAngle () const noexcept
| Returns the line's angle.
Line< float > | toFloat () const noexcept
| Casts this line to float coordinates.
Line< double > | toDouble () const noexcept
| Casts this line to double coordinates.
bool | operator== (Line other) const noexcept
| Compares two lines.
bool | operator!= (Line other) const noexcept
| Compares two lines.
Point< ValueType > | getIntersection (Line line) const noexcept
| Finds the intersection between two lines.
bool | intersects (Line line, Point< ValueType > &intersection) const noexcept
| Finds the intersection between two lines.
bool | intersects (Line other) const noexcept
| Returns true if this line intersects another.
Point< ValueType > | getPointAlongLine (ValueType distanceFromStart) const noexcept
| Returns the location of the point which is a given distance along this line.
Point< ValueType > | getPointAlongLine (ValueType distanceFromStart, ValueType perpendicularDistance) const noexcept
| Returns a point which is a certain distance along and to the side of this line.
Point< ValueType > | getPointAlongLineProportionally (typename Point< ValueType >::FloatType proportionOfLength) const noexcept
| Returns the location of the point which is a given distance along this line proportional to the line's length.
ValueType | getDistanceFromPoint (Point< ValueType > targetPoint, Point< ValueType > &pointOnLine) const noexcept
| Returns the smallest distance between this line segment and a given point.
ValueType | findNearestProportionalPositionTo (Point< ValueType > point) const noexcept
| Finds the point on this line which is nearest to a given point, and returns its position as a proportional position along the line.
Point< ValueType > | findNearestPointTo (Point< ValueType > point) const noexcept
| Finds the point on this line which is nearest to a given point.
bool | isPointAbove (Point< ValueType > point) const noexcept
| Returns true if the given point lies above this line.
Line | withLengthenedStart (ValueType distanceToLengthenBy) const noexcept
| Returns a lengthened copy of this line.
Line | withShortenedStart (ValueType distanceToShortenBy) const noexcept
| Returns a shortened copy of this line.
Line | withLengthenedEnd (ValueType distanceToLengthenBy) const noexcept
| Returns a lengthened copy of this line.
Line | withShortenedEnd (ValueType distanceToShortenBy) const noexcept
| Returns a shortened copy of this line.

## Static Public Member Functions

static Line | fromStartAndAngle (Point< ValueType > startPoint, ValueType length, ValueType angle) noexcept
| Creates a line from a start point, length and angle.

## Constructors and Destructors

## Line() [1/4]

template<typename ValueType>

juce::Line< ValueType >::Line | ( |  | ) |

default

Creates a line, using (0, 0) as its start and end points.

Referenced by fromStartAndAngle(), getIntersection(), intersects(), intersects(), Line(), operator!=(), operator=(), operator==(), reversed(), toDouble(), toFloat(), withLengthenedEnd(), withLengthenedStart(), withShortenedEnd(), and withShortenedStart().

## Line() [2/4]

template<typename ValueType>

juce::Line< ValueType >::Line | ( | const Line< ValueType > & |  | ) |

default

Creates a copy of another line.

References Line().

## Line() [3/4]

template<typename ValueType>

juce::Line< ValueType >::Line | ( | ValueType | startX,
|  | ValueType | startY,
|  | ValueType | endX,
|  | ValueType | endY )

inline noexcept

Creates a line based on the coordinates of its start and end points.

## Line() [4/4]

template<typename ValueType>

juce::Line< ValueType >::Line | ( | Point< ValueType > | startPoint,
|  | Point< ValueType > | endPoint )

inline noexcept

Creates a line from its start and end points.

## ~Line()

template<typename ValueType>

juce::Line< ValueType >::~Line | ( |  | ) |

default

Destructor.

## Member Functions

## operator=()

template<typename ValueType>

Line & juce::Line< ValueType >::operator= | ( | const Line< ValueType > & |  | ) |

default

Copies a line from another one.

References Line().

## getStartX()

template<typename ValueType>

ValueType juce::Line< ValueType >::getStartX | ( |  | ) | const

inline noexcept

Returns the x coordinate of the line's start point.

## getStartY()

template<typename ValueType>

ValueType juce::Line< ValueType >::getStartY | ( |  | ) | const

inline noexcept

Returns the y coordinate of the line's start point.

## getEndX()

template<typename ValueType>

ValueType juce::Line< ValueType >::getEndX | ( |  | ) | const

inline noexcept

Returns the x coordinate of the line's end point.

## getEndY()

template<typename ValueType>

ValueType juce::Line< ValueType >::getEndY | ( |  | ) | const

inline noexcept

Returns the y coordinate of the line's end point.

## getStart()

template<typename ValueType>

Point< ValueType > juce::Line< ValueType >::getStart | ( |  | ) | const

inline noexcept

Returns the line's start point.

## getEnd()

template<typename ValueType>

Point< ValueType > juce::Line< ValueType >::getEnd | ( |  | ) | const

inline noexcept

Returns the line's end point.

## setStart() [1/2]

template<typename ValueType>

void juce::Line< ValueType >::setStart | ( | ValueType | newStartX,
|  | ValueType | newStartY )

inline noexcept

Changes this line's start point.

## setEnd() [1/2]

template<typename ValueType>

void juce::Line< ValueType >::setEnd | ( | ValueType | newEndX,
|  | ValueType | newEndY )

inline noexcept

Changes this line's end point.

## setStart() [2/2]

template<typename ValueType>

void juce::Line< ValueType >::setStart | ( | const Point< ValueType > | newStart | ) |

inline noexcept

Changes this line's start point.

## setEnd() [2/2]

template<typename ValueType>

void juce::Line< ValueType >::setEnd | ( | const Point< ValueType > | newEnd | ) |

inline noexcept

Changes this line's end point.

## reversed()

template<typename ValueType>

Line juce::Line< ValueType >::reversed | ( |  | ) | const

inline noexcept

Returns a line that is the same as this one, but with the start and end reversed,.

References Line().

## applyTransform()

template<typename ValueType>

void juce::Line< ValueType >::applyTransform | ( | const AffineTransform & | transform | ) |

inline noexcept

Applies an affine transform to the line's start and end points.

## getLength()

template<typename ValueType>

ValueType juce::Line< ValueType >::getLength | ( |  | ) | const

inline noexcept

Returns the length of the line.

Referenced by juce::Parallelogram< ValueType >::getHeight(), getPointAlongLine(), juce::Parallelogram< ValueType >::getWidth(), withShortenedEnd(), and withShortenedStart().

## getLengthSquared()

template<typename ValueType>

ValueType juce::Line< ValueType >::getLengthSquared | ( |  | ) | const

inline noexcept

Returns the length of the line.

## isVertical()

template<typename ValueType>

bool juce::Line< ValueType >::isVertical | ( |  | ) | const

inline noexcept

Returns true if the line's start and end x coordinates are the same.

## isHorizontal()

template<typename ValueType>

bool juce::Line< ValueType >::isHorizontal | ( |  | ) | const

inline noexcept

Returns true if the line's start and end y coordinates are the same.

## getAngle()

template<typename ValueType>

Point< ValueType >::FloatType juce::Line< ValueType >::getAngle | ( |  | ) | const

inline noexcept

Returns the line's angle.

This value is the number of radians clockwise from the 12 o'clock direction, where the line's start point is considered to be at the centre.

## fromStartAndAngle()

template<typename ValueType>

Line juce::Line< ValueType >::fromStartAndAngle | ( | Point< ValueType > | startPoint,
|  | ValueType | length,
|  | ValueType | angle )

inline static noexcept

Creates a line from a start point, length and angle.

This angle is the number of radians clockwise from the 12 o'clock direction, where the line's start point is considered to be at the centre.

References Line().

## toFloat()

template<typename ValueType>

Line< float > juce::Line< ValueType >::toFloat | ( |  | ) | const

inline noexcept

Casts this line to float coordinates.

References Line().

## toDouble()

template<typename ValueType>

Line< double > juce::Line< ValueType >::toDouble | ( |  | ) | const

inline noexcept

Casts this line to double coordinates.

References Line().

## operator==()

template<typename ValueType>

bool juce::Line< ValueType >::operator== | ( | Line< ValueType > | other | ) | const

inline noexcept

Compares two lines.

References Line().

## operator!=()

template<typename ValueType>

bool juce::Line< ValueType >::operator!= | ( | Line< ValueType > | other | ) | const

inline noexcept

Compares two lines.

References Line().

## getIntersection()

template<typename ValueType>

Point< ValueType > juce::Line< ValueType >::getIntersection | ( | Line< ValueType > | line | ) | const

inline noexcept

Finds the intersection between two lines.

Parameters

  line | the line to intersect with

Returns
  the point at which the lines intersect, even if this lies beyond the end of the lines

References Line().

## intersects() [1/2]

template<typename ValueType>

bool juce::Line< ValueType >::intersects | ( | Line< ValueType > | line,
|  | Point< ValueType > & | intersection ) const

inline noexcept

Finds the intersection between two lines.

Parameters

  line | the other line
  intersection | the position of the point where the lines meet (or where they would meet if they were infinitely long) the intersection (if the lines intersect). If the lines are parallel, this will just be set to the position of one of the line's endpoints.

Returns
  true if the line segments intersect; false if they don't. Even if they don't intersect, the intersection coordinates returned will still be valid

References Line().

## intersects() [2/2]

template<typename ValueType>

bool juce::Line< ValueType >::intersects | ( | Line< ValueType > | other | ) | const

inline noexcept

Returns true if this line intersects another.

References juce::ignored, and Line().

## getPointAlongLine() [1/2]

template<typename ValueType>

Point< ValueType > juce::Line< ValueType >::getPointAlongLine | ( | ValueType | distanceFromStart | ) | const

inline noexcept

Returns the location of the point which is a given distance along this line.

Parameters

  distanceFromStart | the distance to move along the line from its start point. This value can be negative or longer than the line itself

See also
  getPointAlongLineProportionally

References juce::approximatelyEqual(), and getLength().

Referenced by withShortenedEnd(), and withShortenedStart().

## getPointAlongLine() [2/2]

template<typename ValueType>

Point< ValueType > juce::Line< ValueType >::getPointAlongLine | ( | ValueType | distanceFromStart,
|  | ValueType | perpendicularDistance ) const

inline noexcept

Returns a point which is a certain distance along and to the side of this line.

This effectively moves a given distance along the line, then another distance perpendicularly to this, and returns the resulting position.

Parameters

  distanceFromStart | the distance to move along the line from its start point. This value can be negative or longer than the line itself
  perpendicularDistance | how far to move sideways from the line. If you're looking along the line from its start towards its end, then a positive value here will move to the right, negative value move to the left.

References juce::juce_hypot().

## getPointAlongLineProportionally()

template<typename ValueType>

Point< ValueType > juce::Line< ValueType >::getPointAlongLineProportionally | ( | typename Point< ValueType >::FloatType | proportionOfLength | ) | const

inline noexcept

Returns the location of the point which is a given distance along this line proportional to the line's length.

Parameters

  proportionOfLength | the distance to move along the line from its start point, in multiples of the line's length. So a value of 0.0 will return the line's start point and a value of 1.0 will return its end point. (This value can be negative or greater than 1.0).

See also
  getPointAlongLine

Referenced by findNearestPointTo().

## getDistanceFromPoint()

template<typename ValueType>

ValueType juce::Line< ValueType >::getDistanceFromPoint | ( | Point< ValueType > | targetPoint,
|  | Point< ValueType > & | pointOnLine ) const

inline noexcept

Returns the smallest distance between this line segment and a given point.

So if the point is close to the line, this will return the perpendicular distance from the line; if the point is a long way beyond one of the line's end-point's, it'll return the straight-line distance to the nearest end-point.

pointOnLine receives the position of the point that is found.

Returns
  the point's distance from the line

See also
  getPositionAlongLineOfNearestPoint

## findNearestProportionalPositionTo()

template<typename ValueType>

ValueType juce::Line< ValueType >::findNearestProportionalPositionTo | ( | Point< ValueType > | point | ) | const

inline noexcept

Finds the point on this line which is nearest to a given point, and returns its position as a proportional position along the line.

Returns
  a value 0 to 1.0 which is the distance along this line from the line's start to the point which is nearest to the point passed-in. To turn this number into a position, use getPointAlongLineProportionally().

See also
  getDistanceFromPoint, getPointAlongLineProportionally

References juce::jlimit().

Referenced by findNearestPointTo().

## findNearestPointTo()

template<typename ValueType>

Point< ValueType > juce::Line< ValueType >::findNearestPointTo | ( | Point< ValueType > | point | ) | const

inline noexcept

Finds the point on this line which is nearest to a given point.

See also
  getDistanceFromPoint, findNearestProportionalPositionTo

References findNearestProportionalPositionTo(), and getPointAlongLineProportionally().

## isPointAbove()

template<typename ValueType>

bool juce::Line< ValueType >::isPointAbove | ( | Point< ValueType > | point | ) | const

inline noexcept

Returns true if the given point lies above this line.

The return value is true if the point's y coordinate is less than the y coordinate of this line at the given x (assuming the line extends infinitely in both directions).

## withLengthenedStart()

template<typename ValueType>

Line juce::Line< ValueType >::withLengthenedStart | ( | ValueType | distanceToLengthenBy | ) | const

inline noexcept

Returns a lengthened copy of this line.

This will extend the line by a certain amount by moving the start away from the end (leaving the end-point the same), and return the new line.

References Line(), and withShortenedStart().

## withShortenedStart()

template<typename ValueType>

Line juce::Line< ValueType >::withShortenedStart | ( | ValueType | distanceToShortenBy | ) | const

inline noexcept

Returns a shortened copy of this line.

This will chop off part of the start of this line by a certain amount, (leaving the end-point the same), and return the new line.

References getLength(), getPointAlongLine(), juce::jmin(), and Line().

Referenced by withLengthenedStart().

## withLengthenedEnd()

template<typename ValueType>

Line juce::Line< ValueType >::withLengthenedEnd | ( | ValueType | distanceToLengthenBy | ) | const

inline noexcept

Returns a lengthened copy of this line.

This will extend the line by a certain amount by moving the end away from the start (leaving the start-point the same), and return the new line.

References Line(), and withShortenedEnd().

## withShortenedEnd()

template<typename ValueType>

Line juce::Line< ValueType >::withShortenedEnd | ( | ValueType | distanceToShortenBy | ) | const

inline noexcept

Returns a shortened copy of this line.

This will chop off part of the end of this line by a certain amount, (leaving the start-point the same), and return the new line.

References getLength(), getPointAlongLine(), juce::jmin(), and Line().

Referenced by withLengthenedEnd().

### Purchase

Get JUCE

### Discover

What's New in JUCE Features

### Learn

Documentaion Tutorials Made with JUCE Resources

### Support

JUCE Forum Newsletter Archive

### About

Contact Us JUCE Legal JUCE Licensing FAQ

### Events

Audio Developer Conference
© Raw Material Software Limited